fin = open("s5sis.txt", 'r')
t = [ line.split(' ') for line in fin.read().split('\n') if line ]
fin.close()

n = int(t[0][0])

adj_matrix = [ [1e309]*n for i in range(n) ]

for i in range(n):
    adj_matrix[i][i] = 0

for line in t[1:]:
    i, j, w = int(line[0])-1, int(line[1])-1, int(line[2])
    if adj_matrix[i][j] == 1e309 or adj_matrix[i][j] > w:
        adj_matrix[i][j] = w
        adj_matrix[j][i] = w

for k in range(n):
    for i in range(n):
        for j in range(n):
            if adj_matrix[i][k] + adj_matrix[k][j] < adj_matrix[i][j]:
                adj_matrix[i][j] = adj_matrix[i][k] + adj_matrix[k][j]
                adj_matrix[j][i] = adj_matrix[i][j]

maxdist = max([ max(row) for row in adj_matrix ])
if maxdist == 1e309:
    maxdist = "INF"
fout = open("s5val.txt", 'w')
fout.write(str(maxdist))
fout.close()
