fin = open("s4sis.txt", 'r')
t = [ line.split(' ') for line in fin.read().split('\n') if line ]
fin.close()

n = int(t[0][0])
m = int(t[0][1])
tn = int(t[0][2])

adj_list = [ [] for i in range(n) ]

for i in range(m):
    line = t[i+1]
    i = int(line[0])-1
    j = int(line[1])-1
    w = int(line[2])
    
    adj_list[i].append((j,w))
    adj_list[j].append((i,w))

distances = [1e309]*n
distances[0] = 0
beenthere = [False]*n
nodes_to_go = n-1

while nodes_to_go > 0:
    minnodedist = 1e309
    mindistnode = 0
    for i in range(n):
        if distances[i] < 1e309 and distances[i] < minnodedist and not beenthere[i]:
            minnodedist = distances[i]
            mindistnode = i
    if minnodedist >= 1e309:
        break
    
    beenthere[mindistnode] = True
    
    for neighbour, w in adj_list[mindistnode]:
        if not beenthere[neighbour] and minnodedist+w < distances[neighbour]:
            distances[neighbour] = minnodedist+w

mintoilet = 1e309
for i in range(tn):
    toilet = int(t[m+i+1][0])-1
    if distances[toilet] < mintoilet:
        mintoilet = distances[toilet]
if mintoilet == 1e309:
    mintoilet = "EI OLE"

fout = open("s4val.txt", 'w')
fout.write(str(mintoilet))
fout.close()
